using System;
using System.Collections.Generic;
using System.Data.SqlTypes;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace RDH.Data.Models
{
    [Serializable]
    [DataContract]
    public partial class StorageSpacePortableLink : BaseModel
    {
        private Guid _key;
        private Guid? _storagespacekey;
        private Double? _maxquantity;
        private Double? _alartquantity;
        private Double? _currentquantity;
        private Guid? _createby;
        private bool? _isallowmultilot;
        private Guid? _portableStorageKey;
        private Guid? _devicekey;
        private bool? _flag;
        private DateTime? _clienttime;
        private DateTime? _servertime;
        private string _ext01;
        private string _ext02;
        private string _ext03;
        private string _ext04;
        private string _ext05;
        private string _ext06;
        private string _ext07;
        private string _ext08;
        private string _ext09;
        private string _ext10;
        private StorageSpace _storagespace;
        private DispensingDevice _dispensingdevice;
        private PortableStorage _portableStorage;

        #region Public Properties
        [DataMember]
        public virtual Guid Key
        {
            get { return _key; }
            set
            {
                _key = value;
                OnPropertyChanged("Key");
            }
        }
        [DataMember]
        public virtual Guid? StorageSpaceKey
        {
            get { return _storagespacekey; }
            set
            {
                _storagespacekey = value;
                OnPropertyChanged("StorageSpaceKey");
            }
        }
        [DataMember]
        public virtual Double? MaxQuantity
        {
            get { return _maxquantity; }
            set
            {
                _maxquantity = value;
                OnPropertyChanged("MaxQuantity");
            }
        }
        [DataMember]
        public virtual Double? AlartQuantity
        {
            get { return _alartquantity; }
            set
            {
                _alartquantity = value;
                OnPropertyChanged("AlartQuantity");
            }
        }
        [DataMember]
        public virtual Double? CurrentQuantity
        {
            get { return _currentquantity; }
            set
            {
                _currentquantity = value;
                OnPropertyChanged("CurrentQuantity");
            }
        }
        [DataMember]
        public virtual Guid? CreateBy
        {
            get { return _createby; }
            set
            {
                _createby = value;
                OnPropertyChanged("CreateBy");
            }
        }
        [DataMember]
        public virtual bool? IsAllowMultiLot
        {
            get { return _isallowmultilot; }
            set
            {
                _isallowmultilot = value;
                OnPropertyChanged("IsAllowMultiLot");
            }
        }
        [DataMember]
        public virtual Guid? PortableStorageKey
        {
            get { return _portableStorageKey; }
            set
            {
                _portableStorageKey = value;
                OnPropertyChanged("PortableStorageKey");
            }
        }
        [DataMember]
        public virtual Guid? DeviceKey
        {
            get { return _devicekey; }
            set
            {
                _devicekey = value;
                OnPropertyChanged("DeviceKey");
            }
        }
        [DataMember]
        public virtual bool? Flag
        {
            get { return _flag; }
            set
            {
                _flag = value;
                OnPropertyChanged("Flag");
            }
        }
        [DataMember]
        public virtual DateTime? ClientTime
        {
            get { return _clienttime; }
            set
            {
                _clienttime = value;
                OnPropertyChanged("ClientTime");
            }
        }
        [DataMember]
        public virtual DateTime? ServerTime
        {
            get { return _servertime; }
            set
            {
                _servertime = value;
                OnPropertyChanged("ServerTime");
            }
        }
        /// <summary>
        /// 获取或设置配置状态
        /// </summary>
        [DataMember]
        public virtual string Ext01
        {
            get { return _ext01; }
            set
            {
                _ext01 = value;
                OnPropertyChanged("Ext01");
            }
        }
        /// <summary>
        /// 获取或设置配置类型
        /// </summary>
        [DataMember]
        public virtual string Ext02
        {
            get { return _ext02; }
            set
            {
                _ext02 = value;
                OnPropertyChanged("Ext02");
            }
        }
        /// <summary>
        /// 获取或设置单元格是否打开失败的标识。如果不为空，则表示其打开失败。
        /// </summary>
        [DataMember]
        public virtual string Ext03
        {
            get { return _ext03; }
            set
            {
                _ext03 = value;
                OnPropertyChanged("Ext03");
            }
        }
        [DataMember]
        public virtual string Ext04
        {
            get { return _ext04; }
            set
            {
                _ext04 = value;
                OnPropertyChanged("Ext04");
            }
        }
        [DataMember]
        public virtual string Ext05
        {
            get { return _ext05; }
            set
            {
                _ext05 = value;
                OnPropertyChanged("Ext05");
            }
        }
        [DataMember]
        public virtual string Ext06
        {
            get { return _ext06; }
            set
            {
                _ext06 = value;
                OnPropertyChanged("Ext06");
            }
        }
        [DataMember]
        public virtual string Ext07
        {
            get { return _ext07; }
            set
            {
                _ext07 = value;
                OnPropertyChanged("Ext07");
            }
        }
        [DataMember]
        public virtual string Ext08
        {
            get { return _ext08; }
            set
            {
                _ext08 = value;
                OnPropertyChanged("Ext08");
            }
        }
        [DataMember]
        public virtual string Ext09
        {
            get { return _ext09; }
            set
            {
                _ext09 = value;
                OnPropertyChanged("Ext09");
            }
        }
        [DataMember]
        public virtual string Ext10
        {
            get { return _ext10; }
            set
            {
                _ext10 = value;
                OnPropertyChanged("Ext10");
            }
        }
        public StorageSpace StorageSpace
        {
            get { return _storagespace; }
            set
            {
                _storagespace = value;
                OnPropertyChanged("StorageSpace");
            }
        }
        public DispensingDevice DispensingDevice
        {
            get { return _dispensingdevice; }
            set
            {
                _dispensingdevice = value;
                OnPropertyChanged("DispensingDevice");
            }
        }
        public PortableStorage PortableStorage
        {
            get { return _portableStorage; }
            set
            {
                _portableStorage = value;
                OnPropertyChanged("PortableStorage");
            }
        }
        public Boolean IsHandled { get; set; }
        #endregion
        public StorageSpacePortableLink Clone()
        {
            return new StorageSpacePortableLink()
            {
                _alartquantity = this._alartquantity,
                _clienttime = this._clienttime,
                _createby = this._createby,
                _createtime = this._createtime,
                _currentquantity = this._currentquantity,
                _devicekey = this._devicekey,
                _dispensingdevice = this._dispensingdevice,
                _ext01 = this._ext01,
                _ext02 = this._ext02,
                _ext03 = this._ext03,
                _ext04 = this._ext04,
                _ext05 = this._ext05,
                _ext06 = this._ext06,
                _ext07 = this._ext07,
                _ext08 = this._ext08,
                _ext09 = this._ext09,
                _ext10 = this._ext10,
                _flag = this._flag,
                _isallowmultilot = this._isallowmultilot,
                _portableStorage = this._portableStorage,
                _portableStorageKey = this._portableStorageKey,
                _key = this._key,
                _maxquantity = this._maxquantity,
                _servertime = this._servertime,
                _storagespace = this._storagespace,
                _storagespacekey = this._storagespacekey,
            };
        }
        public override string ToString()
        {
            return String.Format("{0}, {1}, {2}", _storagespace == null ? "NULL" : _storagespace.ToString(), _ext02, _ext01);
        }
    }

}